xfstests: rename configure.in to configure.ac
[xfstests-dev.git] / 075
1 #! /bin/bash
2 # FS QA Test No. 075
3 #
4 # fsx (non-AIO variant)
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=nathans@sgi.com
26
27 seq=`basename $0`
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=0        # success is the default!
33 trap "_cleanup; exit \$status" 0 1 2 3 15
34
35 _cleanup()
36 {
37     cd /
38     rm -rf $testdir/fsx.* $tmp.*
39     _cleanup_testdir
40 }
41
42 # get standard environment, filters and checks
43 . ./common.rc
44 . ./common.filter
45
46 _do_test()
47 {
48     _n="$1"
49     _param="$2"
50
51     out=$testdir/fsx
52     rm -rf $out
53     if ! mkdir $out
54     then
55         echo "    failed to mkdir $out"
56         status=1
57         exit
58     fi
59
60     _filter_param=`echo "$_param" | sed\
61         -e 's/-N [0-9][0-9]*/-N numops/' \
62         -e 's/-l [0-9][0-9]*/-l filelen/'`
63
64     echo ""
65     echo "-----------------------------------------------"
66     echo "fsx.$_n : $_filter_param"
67     echo "-----------------------------------------------"
68
69     if [ "$FSTYP" != "xfs" ]
70     then
71         if [ "$_n" = "1" -o "$_n" = "3" ]
72         then
73             # HACK: only xfs handles preallocation (-x) so just skip this test
74             return
75         fi
76     fi
77
78     # This cd and use of -P gets full debug on $here (not TEST_DEV)
79     cd $out
80     if ! $here/ltp/fsx $_param -P $here $seq.$_n &>/dev/null
81     then
82         echo "    fsx ($_param) failed, $? - compare $seq.$_n.{good,bad,fsxlog}"
83         mv $out/$seq.$_n $here/$seq.$_n.full
84         od -xAx $here/$seq.$_n.full > $here/$seq.$_n.bad
85         od -xAx $here/$seq.$_n.fsxgood > $here/$seq.$_n.good
86         status=1
87         exit
88     fi
89
90     cd $here
91     _check_test_fs
92 }
93
94 _usage()
95 {
96     echo "$0: [-l filelen] [-n numops1] [-N numops2]"
97 }
98
99 _process_args()
100 {
101     while getopts "l:n:N:?" c $@
102     do
103         case $c
104         in
105             l)
106                 filelen=$OPTARG
107                 param_type="$param_type, overidde -l"
108                 ;;
109             N)
110                 numops2=$OPTARG
111                 param_type="$param_type, overidde -N"
112                 ;;
113             n)
114                 numops1=$OPTARG
115                 param_type="$param_type, overidde -n"
116                 ;;
117             ?)
118                 _usage
119                 exit    
120                 ;;
121         esac
122     done
123 }
124
125
126 # real QA test starts here
127 _supported_fs generic
128 _supported_os IRIX Linux
129
130 size10=`expr 10 \* 1024 \* 1024`        # 10 megabytes
131 filelen=$size10
132 numops1=1000
133 numops2=10000
134
135 # can override the params here
136 _process_args "$@"
137
138 echo "Params are for $param_type" >>$seq.full
139 echo "Params: n = $numops1 N = $numops2 l = $filelen" >>$seq.full
140
141 _setup_testdir
142
143 rm -f $here/$seq.full
144 echo "brevity is wit..."
145
146 _check_test_fs
147
148 # Options:
149 # -d: debug output for all operations
150 # -l flen: the upper bound on file size (default 262144)
151 # -o oplen: the upper bound on operation size
152 # -N numops: total # operations to do (default infinity)
153 # -P: save .fsxlog and .fsxgood files in dirpath (default ./)
154 # -S seed: for random # generator (default 1) 0 gets timestamp
155 # -x: pre-allocate file space, exercising unwritten extents
156
157 _do_test 0 "-d -N $numops1 -S 0"
158 _do_test 1 "-d -N $numops1 -S 0 -x"
159 _do_test 2 "-d -N $numops2 -l $filelen -S 0"
160 _do_test 3 "-d -N $numops2 -l $filelen -S 0 -x"
161
162 rm -f $seq.*.fsx{good,log}
163 exit 0